## ros-indigo-libmongocxx-ros 0.4.2

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.3)
project(libmongocxx_ros)

find_package(catkin REQUIRED)

find_package(OpenSSL REQUIRED)
# workaround for exposing OpenSSL libraries
set(OpenSSL_LIBRARIES ${OPENSSL_LIBRARIES})
set(OpenSSL_INCLUDE_DIRS ${OPENSSL_INCLUDE_DIR})

if (${CMAKE_SYSTEM_NAME} MATCHES "Darwin")
    set(LIB_EXT dylib)
else()
    set(LIB_EXT so)
endif()

#for ROS indigo compile mongocxx without c++11 support
if(DEFINED ENV{ROS_DISTRO})
  if(NOT $ENV{ROS_DISTRO} STREQUAL "indigo")
    set(SCONS_CXX11_FLAG "--c++11=on")
    message(STATUS "Building with C++11 support")
  else() 
    message(STATUS "ROS Indigo: building without C++11 support")
  endif()
else()
  message(STATUS "Environmental variable ROS_DISTRO not defined, checking OS version")
  file (STRINGS /etc/os-release RELEASE_CODENAME 
 	REGEX "VERSION_CODENAME=")
  message(STATUS ${RELEASE_CODENAME})
  if(NOT ${RELEASE_CODENAME} MATCHES "trusty")	
    set(SCONS_CXX11_FLAG "--c++11=on")
    message(STATUS "Building with C++11 support")
  else()
    message(STATUS "Building without C++11 support")
  endif()
endif()

# find MongoClient from system first
# if not found, downloads and compiles from sources
set(CMAKE_MODULE_PATH "${PROJECT_SOURCE_DIR}/cmake/" ${CMAKE_MODULE_PATH})
find_package(MongoClient)
if (MongoClient_FOUND)
  message(STATUS "Found System MongoClient. Copying them into ROS workspace")
  add_custom_command(OUTPUT ${CATKIN_DEVEL_PREFIX}/include
    COMMAND ${CMAKE_COMMAND} -E make_directory ${CATKIN_DEVEL_PREFIX}/include)
  add_custom_command(OUTPUT ${CATKIN_DEVEL_PREFIX}/include/mongo
    COMMAND ${CMAKE_COMMAND} -E copy_directory ${MongoClient_INCLUDE_DIR}/mongo ${CATKIN_DEVEL_PREFIX}/include/mongo
    DEPENDS ${CATKIN_DEVEL_PREFIX}/include)
  add_custom_command(OUTPUT ${PROJECT_SOURCE_DIR}/include/mongo
    COMMAND ${CMAKE_COMMAND} -E copy_directory ${CATKIN_DEVEL_PREFIX}/include/mongo ${PROJECT_SOURCE_DIR}/include/mongo
    DEPENDS ${CATKIN_DEVEL_PREFIX}/include/mongo)
  add_custom_command(OUTPUT ${CATKIN_DEVEL_PREFIX}/lib
    COMMAND ${CMAKE_COMMAND} -E make_directory ${CATKIN_DEVEL_PREFIX}/lib)
  add_custom_command(OUTPUT ${CATKIN_DEVEL_PREFIX}/lib/libmongoclient.${LIB_EXT}
    COMMAND ${CMAKE_COMMAND} -E copy ${MongoClient_LIBRARY} ${CATKIN_DEVEL_PREFIX}/lib/libmongoclient.${LIB_EXT}
    DEPENDS ${CATKIN_DEVEL_PREFIX}/lib)
  add_custom_target(mongocxx
    DEPENDS
    ${CATKIN_DEVEL_PREFIX}/lib/libmongoclient.${LIB_EXT}
    ${PROJECT_SOURCE_DIR}/include/mongo
    ${CATKIN_DEVEL_PREFIX}/include/mongo)
else()
  message(STATUS "Not Found System MongoClient. Downloading...")
  include(ProcessorCount)
  processorcount(PROCESSOR_COUNT)
  include(ExternalProject)
  externalproject_add(mongocxx
    GIT_REPOSITORY https://github.com/mongodb/mongo-cxx-driver.git
    GIT_TAG releases/legacy
    PREFIX "${CMAKE_CURRENT_BINARY_DIR}/mongocxx"
    BUILD_IN_SOURCE 1
    UPDATE_COMMAND ""
    CONFIGURE_COMMAND ""
    BUILD_COMMAND scons -j ${PROCESSOR_COUNT} --ssl --sharedclient --disable-warnings-as-errors --prefix=${CATKIN_DEVEL_PREFIX} --cpppath=${OPENSSL_INCLUDE_DIR} --libpath=${OPENSSL_ROOT_DIR}/lib ${SCONS_CXX11_FLAG} install && mkdir -p ${CMAKE_CURRENT_SOURCE_DIR}/include && ${CMAKE_COMMAND} -E copy_directory ${CATKIN_DEVEL_PREFIX}/include ${CMAKE_CURRENT_SOURCE_DIR}/include
    INSTALL_COMMAND ""
  )
endif()

# dependencies of MongoClient
find_package(Boost REQUIRED COMPONENTS system thread program_options filesystem)


catkin_package(
  LIBRARIES mongoclient
  INCLUDE_DIRS include
  DEPENDS Boost OpenSSL)

add_library(mongoclient_imp SHARED IMPORTED)
set_target_properties(mongoclient_imp PROPERTIES IMPORTED_LOCATION ${CATKIN_DEVEL_PREFIX}/lib/libmongoclient.${LIB_EXT})

add_library(mongoclient)
add_custom_command(TARGET mongoclient
  POST_BUILD COMMAND ${CMAKE_COMMAND} -E copy_if_different ${CATKIN_DEVEL_PREFIX}/lib/libmongoclient.${LIB_EXT} ${CMAKE_LIBRARY_OUTPUT_DIRECTORY}/)
set_target_properties(mongoclient PROPERTIES LINKER_LANGUAGE CXX)

add_dependencies(mongoclient_imp mongocxx)
add_dependencies(mongoclient mongoclient_imp)

# Mark executables and/or libraries for installation
install(TARGETS mongoclient
  ARCHIVE DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
  LIBRARY DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
  RUNTIME DESTINATION ${CATKIN_PACKAGE_BIN_DESTINATION})

# Mark cpp header files for installation
install(DIRECTORY ${CATKIN_DEVEL_PREFIX}/include/
  DESTINATION ${CMAKE_INSTALL_PREFIX}/include
  FILES_MATCHING PATTERN "*.h"
  PATTERN ".svn" EXCLUDE)

=== debian/changelog ===
ros-indigo-libmongocxx-ros (0.4.2-0trusty) trusty; urgency=high

  * instead of lsb-release read /etc/os-version from CMake to find OS version
  * Contributors: Ferenc Balint-Benczedi

 -- Marc Hanheide <marc@hanheide.net>  Mon, 04 Jun 2018 00:00:00 -0000

ros-indigo-libmongocxx-ros (0.4.1-0trusty) trusty; urgency=high

  * check if env. var. exists if not decide based on OS version
  * Contributors: Ferenc Balint-Benczedi

 -- Marc Hanheide <marc@hanheide.net>  Tue, 29 May 2018 00:00:00 -0000

ros-indigo-libmongocxx-ros (0.4.0-0trusty) trusty; urgency=high

  * if compiler supports it use C++11
  * Contributors: Ferenc Balint-Benczedi

 -- Marc Hanheide <marc@hanheide.net>  Wed, 23 May 2018 00:00:00 -0000

ros-indigo-libmongocxx-ros (0.3.8-0trusty) trusty; urgency=high



 -- Marc Hanheide <marc@hanheide.net>  Wed, 02 May 2018 00:00:00 -0000

ros-indigo-libmongocxx-ros (0.3.7-0trusty) trusty; urgency=high

  * Merge pull request #210 <https://github.com/strands-project/mongodb_store/issues/210> from hawesie/kinetic-devel
    Updated to build on OS X with the mongo client legacy version.
  * Updated to build on OS X with the mongo client legacy version.
    This makes a couple of changes. For libmongocxx_ros the paths for openssl are added to the scons command and all ".so" and set to ".so" or ".dylib" depending on platform. For mongodb_log this removes the explicit linking of mongoclient which isn't needed since catkin_libraries includes the lib created by libmongocxx_ros.
  * Merge pull request #207 <https://github.com/strands-project/mongodb_store/issues/207> from furushchev/fix-mongocxx
    Use system mongocxx client if possible
  * libmongocxx_ros: try to use system mongocxx lib if possible
  * Contributors: Nick Hawes, Yuki Furuta

 -- Marc Hanheide <marc@hanheide.net>  Thu, 14 Dec 2017 00:00:00 -0000

ros-indigo-libmongocxx-ros (0.3.6-0trusty) trusty; urgency=high



 -- Marc Hanheide <marc@hanheide.net>  Thu, 14 Sep 2017 00:00:00 -0000

ros-indigo-libmongocxx-ros (0.3.5-0trusty) trusty; urgency=high



 -- Marc Hanheide <marc@hanheide.net>  Sun, 03 Sep 2017 00:00:00 -0000

ros-indigo-libmongocxx-ros (0.3.4-0trusty) trusty; urgency=high



 -- Marc Hanheide <marc@hanheide.net>  Sun, 03 Sep 2017 00:00:00 -0000

ros-indigo-libmongocxx-ros (0.3.3-0trusty) trusty; urgency=high



 -- Marc Hanheide <marc@hanheide.net>  Sat, 02 Sep 2017 00:00:00 -0000

ros-indigo-libmongocxx-ros (0.3.2-0trusty) trusty; urgency=high

  * had to add ca-certificates as build_depend
    as the build step (git clone) in the cmake command to build the binary packages failed
  * Contributors: Marc Hanheide

 -- Marc Hanheide <marc@hanheide.net>  Thu, 31 Aug 2017 00:00:00 -0000

ros-indigo-libmongocxx-ros (0.3.1-0trusty) trusty; urgency=high



 -- Marc Hanheide <marc@hanheide.net>  Thu, 24 Aug 2017 00:00:00 -0000

ros-indigo-libmongocxx-ros (0.2.2-0trusty) trusty; urgency=high

  * fixed wrong install place
  * Contributors: Marc Hanheide

 -- Marc Hanheide <marc@hanheide.net>  Wed, 28 Jun 2017 00:00:00 -0000

ros-indigo-libmongocxx-ros (0.2.1-0trusty) trusty; urgency=high

  * added git which was missing for the build
  * Contributors: Marc Hanheide

 -- Marc Hanheide <marc@hanheide.net>  Wed, 28 Jun 2017 00:00:00 -0000

ros-indigo-libmongocxx-ros (0.2.0-0trusty) trusty; urgency=high

  * attempt to fix the cmake hell
  * fixed install problem
  * some attempts to build libmongocxx internally
  * Contributors: Marc Hanheide

 -- Marc Hanheide <marc@hanheide.net>  Wed, 28 Jun 2017 00:00:00 -0000

=== debian/control ===
Source: ros-indigo-libmongocxx-ros
Section: misc
Priority: extra
Maintainer: Marc Hanheide <marc@hanheide.net>
Build-Depends: debhelper (>= 9.0.0), ca-certificates, git-core, libboost-all-dev, libssl-dev, ros-indigo-catkin, ros-indigo-roscpp, scons
Homepage: https://github.com/mongodb/mongo-cxx-driver
Standards-Version: 3.9.2

Package: ros-indigo-libmongocxx-ros
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libboost-all-dev, libssl-dev, ros-indigo-roscpp
Description: A wrapper for the libmongocxx for mongodb_store

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/indigo/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

%:
	dh $@ -v --buildsystem=cmake

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/indigo/setup.sh" ]; then . "/opt/ros/indigo/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCATKIN_BUILD_BINARY_PACKAGE="1" \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/indigo" \
		-DCMAKE_PREFIX_PATH="/opt/ros/indigo"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/indigo/setup.sh" ]; then . "/opt/ros/indigo/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/indigo/setup.sh" ]; then . "/opt/ros/indigo/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/indigo/setup.sh" ]; then . "/opt/ros/indigo/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-indigo-libmongocxx-ros//opt/ros/indigo/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/indigo/setup.sh" ]; then . "/opt/ros/indigo/setup.sh"; fi && \
	dh_auto_install
